<?php
// $Id: index.php,v 1.2 2006/01/20 23:26:47 FARSUS Exp $
//***********************************************************/
//*                 RUNCMS                              */
//*              Simplicity & ease off use                  */
//*             < http://www.runcms.org >                   */
//***********************************************************/
// Original Author: James Knickelbein
// Author Website : http://www.journeymilwaukee.com
// License Type   : GPL: See /manual/LICENSES/GPL.txt
// --------------------------------------------------------- //
include_once("admin_header.php");
include_once(XOOPS_ROOT_PATH."/class/groupaccess.php");
$eh     = new ErrorHandler(0);
$mytree = new XoopsTree($db->prefix("mydownloads_cat"), "cid", "pid");
// Do this to retrieve the images list...
include_once(XOOPS_ROOT_PATH."/class/xoopslists.php");
include_once(XOOPS_ROOT_PATH."/class/xoopsform/formselect.php");
$imgarr_logos = XoopsLists::getImgListAsArray(XOOPS_ROOT_PATH."/modules/mydownloads/cache/logos");
$select_logos = new XoopsFormSelect("indirlogos", "indirlogos", "", 1, false);
$select_logos->addOption("", "-----");
$select_logos->addOptionArray($imgarr_logos);
$imgarr_shots = XoopsLists::getImgListAsArray(XOOPS_ROOT_PATH."/modules/mydownloads/cache/shots");
$select_shots = new XoopsFormSelect("indirshots", "indirshots", "", 1, false);
$select_shots->addOption("", "-----");
$select_shots->addOptionArray($imgarr_shots);
$files_arr = XoopsLists::getFilesListAsArray(XOOPS_ROOT_PATH."/modules/mydownloads/cache/files");
$files_without_hash = array();
foreach($files_arr as $fname) {
  $fname2 = substr($fname, 33, strlen($fname));
  $files_without_hash[$fname] = $fname2;
}
$select_files = new XoopsFormSelect("indirfiles", "indirfiles", "", 1, false);
$select_files->addOption("", "-----");
$select_files->addOptionArray($files_without_hash);
//---------------------------------------------------------------------------------------//
/**
* Description
*
* @param type $var description
* @return type description
*/
function mydownloads() {
global $db;
xoops_cp_header();
OpenTable();
// Temporarily 'homeless' downloads (to be revised in index.php breakup)
$result = $db->query("SELECT COUNT(*) FROM ".$db->prefix("mydownloads_broken")."");
list($totalbrokendownloads) = $db->fetch_row($result);
if ($totalbrokendownloads > 0) {
  $totalbrokendownloads = "<span style='font-weight: bold'>$totalbrokendownloads</span>";
}
$result2 = $db->query("SELECT COUNT(*) FROM ".$db->prefix("mydownloads_mod")."");
list($totalmodrequests) = $db->fetch_row($result2);
if ($totalmodrequests > 0) {
  $totalmodrequests = "<span style='font-weight: bold'>$totalmodrequests</span>";
}
$result3 = $db->query("SELECT COUNT(*) FROM ".$db->prefix("mydownloads_downloads")." WHERE status=0");
list($totalnewdownloads) = $db->fetch_row($result3);
if ($totalnewdownloads > 0) {
  $totalnewdownloads = "<span style='font-weight: bold'>$totalnewdownloads</span>";
}
?>
- <a href="index.php?op=mydownloadsConfigAdmin"><?php echo _MD_GENERALSET;?></a>
<br /><br />
- <a href="index.php?op=downloadsConfigMenu"><?php echo _MD_ADDMODDELETE;?></a>
<br /><br />
- <a href="index.php?op=listNewDownloads"><?php echo _MD_DLSWAITING;?> (<?php echo $totalnewdownloads;?>)</a>
<br /><br />
- <a href="index.php?op=listBrokenDownloads"><?php echo _MD_BROKENREPORTS;?> (<?php echo $totalbrokendownloads;?>)</a>
<br /><br />
- <a href="index.php?op=listModReq"><?php echo _MD_MODREQUESTS;?> (<?php echo $totalmodrequests;?>)</a>
<?php
$result = $db->query("SELECT COUNT(*) FROM ".$db->prefix("mydownloads_downloads")." WHERE status>0");
list($numrows) = $db->fetch_row($result);
echo "<br /><br /><div align='center'>";
printf(_MD_THEREARE, $numrows);
echo "</div>";
CloseTable();
xoops_cp_footer();
}
//---------------------------------------------------------------------------------------//
/**
* Description
*
* @param type $var description
* @return type description
*/
function listNewDownloads() {
global $db, $myts, $eh, $mytree, $xoopsConfig;
// List downloads waiting for validation
$result  = $db->query("SELECT lid, cid, title, description, url, homepage, version, size, platform, logourl, submitter FROM ".$db->prefix("mydownloads_downloads")." WHERE status=0 ORDER BY date DESC");
$numrows = $db->num_rows($result);
xoops_cp_header();
OpenTable();
echo "<h4><a href='index.php'>"._MAIN."</a>: "._MD_DLSWAITING." ($numrows)</h4><br />";
if ($numrows > 0) {
  while (list($lid, $cid, $title, $description, $url, $homepage, $version, $size, $platform, $logourl, $uid) = $db->fetch_row($result)) {
    $title       = $myts->makeTboxData4Edit($title);
    $url         = $myts->makeTboxData4Edit($url);
    $homepage    = $myts->makeTboxData4Edit($homepage);
    $version     = $myts->makeTboxData4Edit($version);
    $size        = $myts->makeTboxData4Edit($size);
    $platform    = $myts->makeTboxData4Edit($platform);
    $description = $myts->makeTboxData4Edit($description);
    if ($uid != 0) {
      $submitter = XoopsUser::getUnameFromId($uid);
      $submitter = $myts->makeTboxData4Show($submitter);
      } else {
        $submitter = $myts->makeTboxData4Show($xoopsConfig['anonymous']);
      }
?>
<form action="index.php" method="post">
<table width="100%">
<tr><td valign="top"><?php echo _MD_GROUPSACCESS;?></td>
<td valign="top"><?php XoopsDownload::printGroups();?></td></tr>
<tr><td nowrap><?php echo _MD_SUBMITTER;?></td>
<td><a href="<?php echo XOOPS_URL;?>/userinfo.php?uid=<?php echo $uid;?>"><?php echo $submitter;?></a></td>
</tr><tr>
<td nowrap><?php echo _MD_FILETITLE;?></td>
<td><input type="text" class="text" name="title" size="50" maxlength="100" value="<?php echo $title;?>"></td>
</tr><tr>
<td nowrap><?php echo _MD_DLURL;?></td>
<td><input type="text" class="text" name="url" size="50" maxlength="255" value="<?php echo $url;?>"> [ <a href="<?php echo formatURL(XOOPS_URL."/modules/mydownloads/cache/files/", $url);?>" target="_blank"><?php echo _MD_DOWNLOAD;?></a> ]</td>
</tr><tr>
<td nowrap><?php echo _MD_CATEGORYC;?></td>
<td><?php $mytree->makeMySelBox("title", "title", $cid);?></td>
</tr><tr>
<td nowrap><?php echo _MD_SITEURL;?></td>
<td><input type="text" class="text" name="homepage" size="50" maxlength="255" value="<?php echo $homepage;?>"> [ <a href="<?php echo $homepage;?>" target="_blank"><?php echo _MD_VISIT;?></a> ]</td>
</tr><tr>
<td><?php echo _MD_VERSIONC;?></td>
<td><input type="text" class="text" name="version" size="10" maxlength="10" value="<?php echo $version;?>"></td>
</tr><tr>
<td><?php echo _MD_FILESIZEC;?></td>
<td><input type="text" class="text" name="size" size="10" maxlength="8" value="<?php echo $size;?>"> <?php echo _BYTES;?></td>
</tr><tr>
<td><?php echo _MD_PLATFORMC;?></td>
<td><input type="text" class="text" name="platform" size="45" maxlength="50" value="<?php echo $platform;?>"></td>
</tr><tr>
<td valign="top" nowrap><?php echo _MD_DESCRIPTIONC;?></td>
<td>
<?php
//$desc = new XoopsFormDhtmlTextArea('', 'filedesc', $description, 10, 58);
$desc = new XoopsFormDhtmlTextArea('', 'filedesc', $description);
echo $desc->render();
?>
</td>
</tr><tr>
<td align="right">
<input type="hidden" name="op" value="approve">
<input type="hidden" name="lid" value="<?php echo $lid;?>">
<input type="submit" class="button" value="<?php echo _MD_APPROVE;?>">
</form></td>
<td align="left"><?php echo myTextForm("index.php?op=delNewDownload&lid=$lid", _DELETE);?></td>
</tr></table>
<?php
  }
  } else {
    echo _MD_NOSUBMITTED;
  }
CloseTable();
xoops_cp_footer();
}
//---------------------------------------------------------------------------------------//
/**
* Description
*
* @param type $var description
* @return type description
*/
function downloadsConfigMenu() {
global $db, $myts, $eh, $mytree, $select_files, $select_shots;
xoops_cp_header();
$result=$db->query("SELECT COUNT(*) FROM ".$db->prefix("mydownloads_cat")."");
list($numrows) = $db->fetch_row($result);
if ($numrows > 0) {
  OpenTable();
  // If there is a category, add a New Download
$upload = new fileupload();
?>
<form method="post" action="index.php" enctype="multipart/form-data">
<h4><a href="index.php"><?php echo _MAIN;?></a>: <?php echo _MD_ADDNEWFILE;?></h4><br />
<table width="100%"><tr>
<td valign="top"><?php echo _MD_GROUPSACCESS;?></td>
<td valign="top"><?php XoopsDownload::printGroups();?></td></tr>
<tr>
<td><?php echo _MD_FILETITLE;?></td>
<td><input type="text" class="text" name="title" size="50" maxlength="100" /></td>
</tr><tr>
<td valign="top" nowrap><?php echo _MD_DLURL;?></td>
<td>
<?php
echo "<i>"._AM_ADDAFILE."</i><br /><br />";
echo _AM_FILESAVAILLIST."<br />";
$select_files->setExtra("onchange=\"javascript:xoopsGetElementById('url').value = this.options[this.selectedIndex].value;\"");
echo $select_files->render(); ?><br /><br />
<input type="text" class="text" name="url" id="url" size="50" maxlength="255" />
<?php
echo "<br />";
$upload->render(1, "download");
?>
</td>
</tr><tr>
<td>&nbsp;</td>
<td><?php printf(_MD_FILE, "modules/mydownloads/cache/files/");?></td>
</tr><tr>
<td nowrap><?php echo _MD_CATEGORYC;?></td>
<td><?php $mytree->makeMySelBox("title", "title");?></td>
</tr><tr>
<td nowrap><?php echo _MD_SITEURL;?></td>
<td><input type="text" class="text" name="homepage" size="50" maxlength="255" value="http://"></td>
</tr><tr>
<td><?php echo _MD_VERSIONC;?></td>
<td><input type="text" class="text" name="version" size="10" maxlength="10"></td>
</tr><tr>
<td><?php echo _MD_FILESIZEC;?></td>
<td><i><?php echo _AM_DOWNLOADS_BYTES;?></i><br /><input type="text" class="text" name="size" size="10" maxlength="100"> <?php echo _BYTES;?></td>
</tr><tr>
<td><?php echo _MD_PLATFORMC;?></td>
<td><input type="text" class="text" name="platform" size="45" maxlength="60"></td>
</tr><tr>
<td valign="top" nowrap><?php echo _MD_DESCRIPTIONC;?></td>
<td>
<?php
//$desc = new XoopsFormDhtmlTextArea('', 'filedesc', '',10,58);
$desc = new XoopsFormDhtmlTextArea('', 'filedesc', '');
echo $desc->render();
?>
</td>
</tr><tr>
<td valign="top" nowrap><?php echo _MD_SHOTIMAGE;?></td>
<td>
<?php
echo "<i>"._AM_ADDANIMAGE."</i><br /><br />";
echo _AM_IMGAVAILLIST."<br />";
$select_shots->setExtra("onchange=\"javascript:xoopsGetElementById('logourl').value = this.options[this.selectedIndex].value;\"");
echo $select_shots->render(); ?> [<a href="javascript:openWithSelfMain('<?php echo XOOPS_URL."/modules/mydownloads/cache/shots/";?>' + xoopsGetElementById('indirshots').options[xoopsGetElementById('indirshots').selectedIndex].value + '','view',550,200);"><?php echo _PREVIEW;?></a>]<br /><br />
<input type="text" class="text" name="logourl" id="logourl" size="50" maxlength="255">
<?php
echo "<br />";
$upload->render(1, "image");
?>
</td>
</tr><tr>
<td>&nbsp;</td>
<td><?php printf(_MD_SHOT, "modules/mydownloads/cache/images/shots/");?></td>
</tr>
</table>
<br /><br />
<input type="hidden" name="op" value="addDownload" />
<input type="submit" class="button" value="<?php echo _ADD;?>" />
</form>
<?php
CloseTable();
echo "<br />";
OpenTable();
// Modify Download by number
$dwlslist = $db->query("select lid,title from ".$db->prefix("mydownloads_downloads")." order by title asc");
?>
<form method="post" action="index.php">
<h4><?php echo _MD_MODDL;?></h4>
<?php echo _MD_FILEID;?>
<input type="text" class="text" name="lid" size="12" maxlength="11">
<input type="hidden" name="fct" value="mydownloads">
<input type="hidden" name="op" value="modDownload">
<input type="submit" class="button" value="<?php echo _MD_MODIFY;?>">
</form>
<?php
echo "<nobr />";
// Modify Download by name
$dwlslist = $db->query("select lid,title from ".$db->prefix("mydownloads_downloads")." order by title asc");
?>
<form method="post" action="index.php">
<?php echo _MD_FILENAME;?>
<select name="lid" class="select">
<option value="" selected>-----</option>
<?php
while ( $dl = $db->fetch_array($dwlslist) ) {
?>
<option value="<?php echo $dl['lid'];?>"><?php echo $dl['title']?></option>
<?php
}
?>
</select>
<input type="hidden" name="fct" value="mydownloads">
<input type="hidden" name="op" value="modDownload">
<input type="submit" class="button" value="<?php echo _MD_MODIFY;?>">
</form>
<?php
CloseTable();
echo "<br />";
OpenTable();
// Modify Category
?>
<form method="post" action="index.php">
<h4><?php echo _MD_MODCAT;?></h4>
<?php echo _MD_CATEGORYC;?>
<?php $mytree->makeMySelBox("title", "title");?>
<input type="hidden" name="op" value="modCat">
<input type="submit" class="button" value="<?php echo _MD_MODIFY;?>">
</form>
<?php
CloseTable();
echo "<br />";
OpenTable();
// Add a New Sub-Category
?>
<form method="post" action="index.php">
<h4><?php echo _MD_ADDSUB;?></h4>
<?php echo _MD_TITLEC;?>
<input type="text" class="text" name="title" size="30" maxlength="50">
<?php echo _MD_IN;?>
<?php $mytree->makeMySelBox("title", "title");?>
<input type="hidden" name="op" value="addCat">
<input type="submit" class="button" value="<?php echo _ADD;?>">
</form>
<?php
CloseTable();
echo "<br />";
}
// Add a New Main Category
OpenTable();
?>
<form method="post" action="index.php">
<h4><?php echo _MD_ADDMAIN;?></h4>
<?php echo _MD_TITLEC;?>
<input type="text" class="text" name="title" size="30" maxlength="50">
<input type="hidden" name="op" value="addCat">
<input type="submit" class="button" value="<?php echo _ADD;?>">
</form>
<?php
CloseTable();
xoops_cp_footer();
}
//---------------------------------------------------------------------------------------//
/**
* Description
*
* @param type $var description
* @return type description
*/
function delVote() {
global $db, $eh;
$rid = intval($_GET['rid']);
$lid = intval($_GET['lid']);
$query = "DELETE FROM ".$db->prefix("mydownloads_votedata")." WHERE ratingid=$rid";
$db->query($query) or $eh->show("0013");
updaterating($lid);
redirect_header("index.php", 1, _MD_VOTEDELETED);
exit();
}
//---------------------------------------------------------------------------------------//
/**
* Description
*
* @param type $var description
* @return type description
*/
function listBrokenDownloads() {
global $db, $myts, $eh, $xoopsConfig;
$result = $db->query("SELECT reportid, lid, sender, ip FROM ".$db->prefix("mydownloads_broken")." ORDER BY reportid");
$totalbrokendownloads = $db->num_rows($result);
xoops_cp_header();
OpenTable();
echo "<h4><a href='index.php'>"._MAIN."</a>: "._MD_BROKENREPORTS." ($totalbrokendownloads)</h4><br />";
if ($totalbrokendownloads == 0) {
  echo _MD_NOBROKEN;
  } else {
    $colorswitch = "bg1";
    ?>
    <center><?php echo _MD_IGNOREDESC;?><br /><?php echo _MD_DELETEDESC;?></center>
    <br /><br /><br />
    <table align="center" width="90%"><tr>
    <td><b><?php echo _MD_FILETITLE;?></b></td>
    <td><b><?php echo _MD_REPORTER;?></b></td>
    <td><b><?php echo _MD_FILESUBMITTER;?></b></td>
    <td><b><?php echo _MD_IGNORE;?></b></td>
    <td><b><?php echo _EDIT;?></b></td>
    <td><b><?php echo _DELETE;?></b></td>
    </tr>
    <?php
while (list($reportid, $lid, $senderid, $ip) = $db->fetch_row($result)) {
  $result2 = $db->query("SELECT title, url, submitter FROM ".$db->prefix("mydownloads_downloads")." WHERE lid=$lid");
  list($title, $url, $ownerid) = $db->fetch_row($result2);
  $title = $myts->makeTboxData4Show($title);
  if ($senderid != 0) {
    $sender = XoopsUser::getUnameFromId($senderid);
    $sender = $myts->makeTboxData4Show($sender);
    } else {
      $sender = $myts->makeTboxData4Show($xoopsConfig['anonymous']);
    }
  if ($ownerid != 0) {
    $owner = XoopsUser::getUnameFromId($ownerid);
    $owner = $myts->makeTboxData4Show($owner);
    } else {
      $owner = $myts->makeTboxData4Show($xoopsConfig['anonymous']);
    }
  echo "
  <tr>
  <td class='$colorswitch'><a href='".formatURL(XOOPS_URL."/modules/mydownloads/cache/files/", $url)."' target='_blank'>$title</a></td>
  <td class='$colorswitch'><a href='".XOOPS_URL."/userinfo.php?uid=$senderid' target='_blank'>$sender</a> ($ip)</td>
  <td class='$colorswitch'><a href='".XOOPS_URL."/userinfo.php?uid=$ownerid' target='_blank'>$owner</a></td>
  <td class='$colorswitch' align='center'>";
  echo myTextForm("index.php?op=ignoreBrokenDownloads&lid=$lid" , "X");
  echo "</td><td class='$colorswitch' align='center'>";
  echo myTextForm("index.php?op=modDownload&lid=$lid" , "X");
  echo "</td><td class='$colorswitch' align='center'>";
  echo myTextForm("index.php?op=delBrokenDownloads&lid=$lid" , "X");
  echo "</td></tr>";
  if ($colorswitch == "bg1") {
    $colorswitch = "bg3";
    } else {
      $colorswitch="bg1";
    }
  }
  echo "</table>";
}
CloseTable();
xoops_cp_footer();
}
//---------------------------------------------------------------------------------------//
/**
* Description
*
* @param type $var description
* @return type description
*/
function delBrokenDownloads() {
global $db, $_GET, $eh;
$lid = intval($_GET['lid']);
$query = "DELETE FROM ".$db->prefix("mydownloads_broken")." WHERE lid=$lid";
$db->query($query) or $eh->show("0013");
$query  = "SELECT url, logourl FROM ".$db->prefix("mydownloads_downloads")." WHERE lid=$lid";
$result = $db->query($query);
list($url, $logourl) = $db->fetch_row($result);
@unlink("../cache/files/" . basename($url));
@unlink("../cache/shots/" . basename($logourl));
$query = "DELETE FROM ".$db->prefix("mydownloads_downloads")." WHERE lid=$lid";
$db->query($query) or $eh->show("0013");
build_rss();
redirect_header("./index.php?op=listBrokenDownloads", 1, _MD_FILEDELETED);
exit();
}
//---------------------------------------------------------------------------------------//
/**
* Description
*
* @param type $var description
* @return type description
*/
function ignoreBrokenDownloads() {
global $db, $eh;
$lid   = intval($_GET['lid']);
$query = "DELETE FROM ".$db->prefix("mydownloads_broken")." WHERE lid=$lid";
$db->query($query) or $eh->show("0013");
redirect_header("./index.php?op=listBrokenDownloads", 1, _MD_BROKENDELETED);
exit();
}
//---------------------------------------------------------------------------------------//
/**
* Description
*
* @param type $var description
* @return type description
*/
function listModReq() {
global $db, $myts, $eh, $mytree, $mydownloadsConfig;
xoops_cp_header();
OpenTable();
$sql_mod = $db->query("SELECT requestid, lid, cid, title, description, url, homepage, version, size, platform, modifysubmitter FROM ".$db->prefix("mydownloads_mod")." ORDER BY requestid");
$totalmodrequests = $db->num_rows($sql_mod);
echo "<h4><a href='index.php'>"._MAIN."</a>: "._MD_USERMODREQ." ($totalmodrequests)</h4><br />";
if ($totalmodrequests > 0) {
  while (list($requestid, $lid, $cid, $title, $description, $url, $homepage, $version, $size, $platform, $modifysubmitter) = $db->fetch_row($sql_mod)) {
    $cidtitle      = $mytree->getNicePathFromId($cid, "title", XOOPS_URL."/modules/mydownloads/viewcat.php?");
    $cidtitle      = substr($cidtitle, 0, -2);
    $title         = $myts->makeTboxData4Show($title);
    $url           = formatURL(XOOPS_URL."/modules/mydownloads/cache/files/", $myts->makeTboxData4Show($url));
    $homepage      = $myts->makeTboxData4Show($homepage);
    $version       = $myts->makeTboxData4Show($version);
    $size          = $myts->makeTboxData4Show($size);
    $platform      = $myts->makeTboxData4Show($platform);
    $description   = $myts->makeTareaData4Show($description);
    if ($modifysubmitter != 0) {
      $submittername = XoopsUser::getUnameFromId($modifysubmitter);
      $submittername = $myts->makeTareaData4Show($submittername);
    }
    $sql_original = $db->query("SELECT cid, title, description, url, homepage, version, size, platform, submitter FROM ".$db->prefix("mydownloads_downloads")." WHERE lid=$lid");
    list($origcid, $origtitle, $origdescription, $origurl, $orighomepage, $origversion, $origsize, $origplatform, $owner) = $db->fetch_row($sql_original);
    $origcidtitle    = $mytree->getNicePathFromId($origcid, "title", XOOPS_URL."/modules/mydownloads/viewcat.php?");
    $origcidtitle    = substr($origcidtitle, 0, -2);
    $origtitle       = $myts->makeTboxData4Show($origtitle);
    $origurl         = formatURL(XOOPS_URL."/modules/mydownloads/cache/files/", $myts->makeTboxData4Show($origurl));
    $orighomepage    = $myts->makeTboxData4Show($orighomepage);
    $origversion     = $myts->makeTboxData4Show($origversion);
    $origsize        = $myts->makeTboxData4Show($origsize);
    $origplatform    = $myts->makeTboxData4Show($origplatform);
    $origdescription = $myts->makeTareaData4Show($origdescription);
    if ($owner != 0) {
      $ownername       = XoopsUser::getUnameFromId($owner);
      $ownername       = $myts->makeTareaData4Show($ownername);
    }
?>
<hr align="center" size="1" noshade="noshade" />
<table width="100%" cellspacing="0" cellpadding="0"><tr>
<td valign="top"><small><?php echo _MD_REQUESTID;?></small></td>
<td valign="top"><b><?php echo $requestid;?></b></td>
</tr><tr>
<td valign="top"><b><?php echo _MD_PROPOSED;?></b></td>
<td width="50%" rowspan="8" valign="top"><?php echo _MD_DESCRIPTIONC;?><br /><?php echo $description;?></td>
</tr><tr>
<td valign="top"><small><?php echo _MD_FILETITLE;?> <?php echo $title;?></small></td>
</tr><tr>
<td valign="top"><small><?php echo _MD_DLURL;?> <a href="<?php echo $url;?>" target="_blank"><?php echo $url;?></a></small></td>
</tr><tr>
<td valign="top"><small><?php echo _MD_CATEGORYC;?> <?php echo $cidtitle;?></small></td>
</tr><tr>
<td valign="top"><small><?php echo _MD_SITEURL;?> <a href="<?php echo $homepage;?>" target="_blank"><?php echo $homepage;?></a></small></td>
</tr><tr>
<td valign="top"><small><?php echo _MD_VERSIONC;?> <?php echo $version;?></small></td>
</tr><tr>
<td valign="top"><small><?php echo _MD_FILESIZEC;?> <?php echo $size;?></small></td>
</tr><tr>
<td valign="top"><small><?php echo _MD_PLATFORMC;?> <?php echo $platform;?></small></td>
</tr><tr>
<td colspan="2">&nbsp;</td>
</tr><tr>
<td valign="top"><b><?php echo _MD_ORIGINAL;?></b></td>
<td width="50%" rowspan="8" valign="top"><?php echo _MD_DESCRIPTIONC;?><br /><?php echo $origdescription;?></td>
</tr><tr>
<td valign="top"><small><?php echo _MD_FILETITLE;?> <?php echo $origtitle;?></small></td>
</tr><tr>
<td valign="top"><small><?php echo _MD_DLURL;?> <a href="<?php echo $origurl;?>" target="_blank"><?php echo $origurl;?></a></small></td>
</tr><tr>
<td valign="top"><small><?php echo _MD_CATEGORYC;?> <?php echo $origcidtitle;?></small></td>
</tr><tr>
<td valign="top"><small><?php echo _MD_SITEURL;?> <a href="<?php echo $orighomepage;?>" target="_blank"><?php echo $orighomepage;?></a></small></td>
</tr><tr>
<td valign="top"><small><?php echo _MD_VERSIONC;?> <?php echo $origversion;?></small></td>
</tr><tr>
<td valign="top"><small><?php echo _MD_FILESIZEC;?> <?php echo $origsize;?></small></td>
</tr><tr>
<td valign="top"><small><?php echo _MD_PLATFORMC;?> <?php echo $origplatform;?></small></td>
</tr><tr align="center">
<td colspan="2">
<br />
<table width="100%" border="0" cellspacing="0" cellpadding="0"><tr>
<td valign="top" width="35%"><small><?php echo _MD_SUBMITTER;?> <a href="<?php echo XOOPS_URL;?>/userinfo.php?uid=<?php echo $modifysubmitter;?>" target="_blank"><?php echo $submittername;?></a></small></td>
<td valign="top" width="35%"><small><?php echo _MD_OWNER;?> <a href="<?php echo XOOPS_URL;?>/userinfo.php?uid=<?php echo $owner;?>" target="_blank"><?php echo $ownername;?></a></small></td>
<td valign="top" width="5%"><?php echo myTextForm("index.php?op=changeModReq&requestid=$requestid" , _MD_APPROVE);?></td>
<td valign="top" width="5%"><?php echo myTextForm("index.php?op=modDownload&lid=$lid" , _EDIT);?></td>
<td valign="top" width="5%"><?php echo myTextForm("index.php?op=ignoreModReq&requestid=$requestid", _MD_IGNORE);?></td>
</tr></table>
</td>
</tr></table>
<?php
  }
  } else {
    echo _MD_NOMODREQ;
  }
CloseTable();
xoops_cp_footer();
}
//---------------------------------------------------------------------------------------//
/**
* Description
*
* @param type $var description
* @return type description
*/
function changeModReq() {
global $db, $_GET, $eh, $myts;
$requestid = intval($_GET['requestid']);
$sql = "SELECT
  lid,
  cid,
  title,
  url,
  homepage,
  version,
  size,
  platform,
  description
  FROM ".$db->prefix("mydownloads_mod")."
  WHERE requestid=$requestid";
$result = $db->query($sql);
list($lid, $cid, $title, $url, $homepage, $version, $size, $platform, $description) = $db->fetch_row($result);
$title       = $myts->oopsAddSlashesRT($title);
$url         = $myts->oopsAddSlashesRT($url);
$homepage    = $myts->oopsAddSlashesRT($homepage);
$description = $myts->oopsAddSlashesRT($description);
$platform    = $myts->oopsAddSlashesRT($platform);
$sql = "UPDATE ".$db->prefix("mydownloads_downloads")." SET
  cid=$cid,
  title='$title',
  description='$description',
  url='$url',
  homepage='$homepage',
  version='$version',
  size='$size',
  platform='$platform',
  status=2,
  date=".time()."
  WHERE lid=$lid";
$db->query($sql) or $eh->show("0013");
$db->query("DELETE FROM ".$db->prefix("mydownloads_mod")." WHERE requestid=$requestid") or $eh->show("0013");
redirect_header("index.php?op=listModReq", 1, _UPDATED);
exit();
}
//---------------------------------------------------------------------------------------//
/**
* Description
*
* @param type $var description
* @return type description
*/
function ignoreModReq() {
global $db, $_GET, $eh;
$requestid = intval($_GET['requestid']);
$query     = "DELETE FROM ".$db->prefix("mydownloads_mod")." WHERE requestid=$requestid";
$db->query($query) or $eh->show("0013");
redirect_header("./index.php?op=listModReq", 1, _MD_MODREQDELETED);
exit();
}
//---------------------------------------------------------------------------------------//
/**
* Description
*
* @param type $var description
* @return type description
*/
function delDownload() {
global $db, $_GET, $eh;
$lid = intval($_GET['lid']);
$query  = "SELECT url, logourl FROM ".$db->prefix("mydownloads_downloads")." WHERE lid=$lid";
$result = $db->query($query);
list($url, $logourl) = $db->fetch_row($result);
@unlink("../cache/files/" . basename($url));
@unlink("../cache/shots/" . basename($logourl));
$query = "DELETE FROM ".$db->prefix("mydownloads_downloads")." WHERE lid=$lid";
$db->query($query) or $eh->show("0013");
$query = "DELETE FROM ".$db->prefix("mydownloads_votedata")." WHERE lid=$lid";
$db->query($query) or $eh->show("0013");
build_rss();
redirect_header("index.php", 1, _MD_FILEDELETED);
exit();
}
//---------------------------------------------------------------------------------------//
/**
* Description
*
* @param type $var description
* @return type description
*/
function modCat() {
global $db, $xoopsModule, $_POST, $_GET, $myts, $eh, $mytree, $select_logos;
$cid = !empty($_POST["cid"]) ? intval($_POST["cid"]) : intval($_GET["cid"]);
xoops_cp_header();
OpenTable();
echo "<h4><a href='index.php'>"._MAIN."</a>: "._MD_MODCAT."</h4><br />";
$result = $db->query("SELECT pid, title, imgurl, description FROM ".$db->prefix("mydownloads_cat")." WHERE cid=$cid");
global $desc;
list($pid, $title, $imgurl, $description) = $db->fetch_row($result);
$title  = $myts->makeTboxData4Edit($title);
$imgurl = $myts->makeTboxData4Edit($imgurl);
$desc   = $myts->makeTboxData4Edit($description);
?>
<form action="./index.php" method="post" enctype="multipart/form-data">
<?php echo _MD_TITLEC;?><br />
<input type="text" class="text" name="title" value="<?php echo $title;?>" size="51" maxlength="50">
<br /><br />
<?php
echo "<i>"._AM_ADDANIMAGE."</i><br /><br />";
echo _AM_IMGAVAILLIST."<br />";
$select_logos->setValue($imgurl);
$select_logos->setExtra("onchange=\"javascript:xoopsGetElementById('imgurl').value = this.options[this.selectedIndex].value;\"");
echo $select_logos->render(); ?> [<a href="javascript:openWithSelfMain('<?php echo XOOPS_URL."/modules/mydownloads/cache/logos/";?>' + xoopsGetElementById('indirlogos').options[xoopsGetElementById('indirlogos').selectedIndex].value + '','view',550,200);"><?php echo _PREVIEW;?></a>]<br /><br />
<input type="text" class="text" name="imgurl" id="imgurl" value="<?php echo $imgurl;?>" size="51" maxlength="255"><br />
<?php
$upload = new fileupload();
$upload->set_basename($cid, 'image');
$upload->render(1, 'image');
echo "<br />".sprintf(_AM_IMGLOCATION, "modules/".$xoopsModule->dirname()."/cache/logos/");
?>
<br /><br />
<?php echo _MD_DESCRIPTION;?>:<br />
<?php
//$desc = new XoopsFormDhtmlTextArea('', 'desc', $desc, 10, 58);
$desc = new XoopsFormDhtmlTextArea('', 'desc', $desc);
echo $desc->render();
?>
<br /><br />
<?php echo _MD_PARENT;?><br />
<?php $mytree->makeMySelBox("title", "title", $pid, 1, "pid");?>
<br /><br />
<input type="hidden" name="cid" value="<?php echo $cid;?>" />
<input type="hidden" name="op" value="modCatS" /><br />
<input type="submit" class="button" value="<?php echo _SAVE;?>" />
<input type="button" class="button" value="<?php echo _DELETE;?>" onclick="location='index.php?pid=<?php echo $pid;?>&cid=<?php echo $cid;?>&op=delCat';" />
<input type="button" class="button" value="<?php echo _CANCEL;?>" onclick="location='index.php';" />
</form>
<?php
CloseTable();
xoops_cp_footer();
}
//---------------------------------------------------------------------------------------//
/**
* Description
*
* @param type $var description
* @return type description
*/
function modCatS() {
global $db, $myts, $_POST, $_FILES;
$cid         = intval($_POST['cid']);
$pid         = intval($_POST['pid']);
$imgurl      = $myts->makeTboxData4Save($_POST['imgurl']);
$title       = $myts->makeTboxData4Save($_POST['title']);
$description = $myts->makeTboxData4Save($_POST['desc']);
if ( !empty($_FILES['image']['name']) ) {
  $upload = new fileupload();
  $upload->set_upload_dir("../cache/logos/");
  $upload->set_accepted("gif|jpg|png");
  $upload->set_overwrite(2);
  $result = $upload->upload();
  if ($result['image']) {
    $imgurl = $result['image']['filename'];
    } else {
      redirect_header("index.php?op=modCat&cid=$cid", 3, $upload->errors());
      exit();
    }
}
// katagorier
if ( $cid == $pid ) {
  redirect_header("index.php?op=modCat&cid=$cid", 3, _AM_DOWNLOADS_SELECTCORRECTPID);
  exit();
}
$catlist = new XoopsTree($db->prefix("mydownloads_cat"),"cid","pid");
$allcats = $catlist->getAllParentId($pid);
foreach ( $allcats as $cat ) {
  if ( $cat == $cid ) {
    redirect_header("index.php?op=modCat&cid=$cid", 3, _AM_DOWNLOADS_SELECTCORRECTPID);
    exit();
  }
}
$db->query("UPDATE ".$db->prefix("mydownloads_cat")." SET title='$title', imgurl='$imgurl', pid='$pid', description='$description' WHERE cid=$cid");
build_rss();
redirect_header("index.php?op=modCat&cid=$cid", 1, _UPDATED);
exit();
}
//---------------------------------------------------------------------------------------//
/**
* Description
*
* @param type $var description
* @return type description
*/
function addCat() {
global $db, $_POST, $myts, $eh;
$pid   = intval($_POST['cid']);
$title = $myts->makeTboxData4Save($_POST["title"]);
$newid = $db->genId($db->prefix("mydownloads_cat")."_cid_seq");
$query = $db->query("INSERT INTO ".$db->prefix("mydownloads_cat")." VALUES (".intval($newid).", ".intval($pid).", '$title', '', '')") or $eh->show("0013");
if ($newid == 0) {
  $newid = $db->insert_id($query);
}
redirect_header("index.php?op=modCat&cid=$newid", 1, _MD_NEWCATADDED);
exit();
}
//---------------------------------------------------------------------------------------//
/**
* Description
*
* @param type $var description
* @return type description
*/
function delCat() {
global $db, $_GET, $mytree;
$cid = intval($_GET['cid']);
if ($_GET['ok'] == 1) {
  //get all subcategories under the specified category
  $arr  = $mytree->getAllChildId($cid);
  $size = count($arr);
  for ($i=0; $i<$size; $i++) {
    //get all downloads in each subcategory
    $result = $db->query("SELECT lid, url, logourl FROM ".$db->prefix("mydownloads_downloads")." WHERE cid=".$arr[$i]."");
    //now for each download, delete the text data and vote ata associated with the download
    while (list($lid, $url, $logourl) = $db->fetch_row($result)) {
      @unlink("../cache/files/" . basename($url));
      @unlink("../cache/shots/" . basename($logourl));
      $db->query("DELETE FROM ".$db->prefix("mydownloads_votedata")." WHERE lid=$lid");
      $db->query("DELETE FROM ".$db->prefix("mydownloads_downloads")." WHERE lid=$lid");
    }
    //all downloads for each subcategory is deleted, now delete the subcategory data
    $result = $db->query("SELECT imgurl FROM ".$db->prefix("mydownloads_cat")." WHERE cid=".$arr[$i]."");
    list($imgurl) = $db->fetch_row($result);
    @unlink("../cache/logos/" . basename($imgurl));
    $db->query("DELETE FROM ".$db->prefix("mydownloads_cat")." WHERE cid=".$arr[$i]."");
  }
  //all subcategory and associated data are deleted, now delete category data and its associated data
  $result = $db->query("SELECT lid, url, logourl FROM ".$db->prefix("mydownloads_downloads")." WHERE cid=$cid");
  while (list($lid, $url, $logourl) = $db->fetch_row($result)) {
    @unlink("../cache/files/" . basename($url));
    @unlink("../cache/shots/" . basename($logourl));
    $db->query("DELETE FROM ".$db->prefix("mydownloads_votedata")." WHERE lid=$lid");
    $db->query("DELETE FROM ".$db->prefix("mydownloads_downloads")." WHERE lid=$lid");
  }
  $result = $db->query("SELECT imgurl FROM ".$db->prefix("mydownloads_cat")." WHERE cid=$cid");
  list($imgurl) = $db->fetch_row($result);
  @unlink("../cache/logos/" . basename($imgurl));
  $db->query("DELETE FROM ".$db->prefix("mydownloads_cat")." WHERE cid=$cid");
  build_rss();
  redirect_header("index.php", 1, _MD_CATDELETED);
  exit();
  } else {
    xoops_cp_header();
    OpenTable();
    echo "<h4>"._MD_WARNING."</h4><br /><table><tr><td>";
    echo myTextForm("index.php?op=delCat&cid=$cid&ok=1", _YES);
    echo "</td><td>";
    echo myTextForm("index.php", _NO);
    echo "</td></tr></table>";
    CloseTable();
    xoops_cp_footer();
  }
}
//---------------------------------------------------------------------------------------//
/**
* Description
*
* @param type $var description
* @return type description
*/
function addDownload() {
global $db, $myts, $xoopsUser, $eh, $xoopsModule, $_FILES, $_POST;
$groups  = XoopsDownload::makeTboxData4SaveGroups($_POST["group_ids"]);
$homepage    = formatURL($myts->makeTboxData4Save($_POST["homepage"]));
$url         = $myts->makeTboxData4Save($_POST["url"]);
$logourl     = $myts->makeTboxData4Save($_POST["logourl"]);
$title       = $myts->makeTboxData4Save($_POST["title"]);
$version     = $myts->makeTboxData4Save($_POST["version"]);
$size        = $myts->makeTboxData4Save($_POST["size"]);
$platform    = $myts->makeTboxData4Save($_POST["platform"]);
$description = $myts->makeTboxData4Save($_POST["filedesc"]);
$submitter   = intval($xoopsUser->uid());
$result        = $db->query("SELECT COUNT(*) FROM ".$db->prefix("mydownloads_downloads")." WHERE url='$url'");
list($numrows) = $db->fetch_row($result);
// Check if Download exist
if ($numrows > 0) {
  redirect_header("index.php?op=downloadsConfigMenu", 3, _MD_ERROREXIST);
  exit();
}
// Check if Title is empty
if ( empty($title) ) {
  redirect_header("index.php?op=downloadsConfigMenu", 3, _MD_ERRORTITLE);
  exit();
}
// Check if Description is empty
if ( empty($description) ) {
  redirect_header("index.php?op=downloadsConfigMenu", 3, _MD_ERRORDESC);
  exit();
}
if ( empty($size) || !is_numeric($size) ) {
  $size = 0;
}
if ( !empty($_POST['cid']) ) {
  $cid = intval($_POST['cid']);
  } else {
    $cid = 0;
  }
if ( !empty($_FILES['download']['name']) ) {
  $upload = new fileupload();
  $upload->set_upload_dir("../cache/files/", "download");
  $upload->set_upload_dir("../cache/shots/", "image");
  $upload->set_overwrite(2);
  $result = $upload->upload();
  if ($result['download']) {
    $url  = $result['download']['filename'];
    $size = $result['download']['size'];
    } else {
      redirect_header("index.php?op=downloadsConfigMenu", 3, $upload->errors());
      exit();
    }
if ( !empty($_FILES['image']['name']) ) {
  if ($result['image']) {
    $logourl = $result['image']['filename'];
    } else {
      redirect_header("index.php?op=downloadsConfigMenu", 3, $upload->errors());
      exit();
    }
  }
}
// Check if URL is empty
if ( empty($url) ) {
  redirect_header("index.php?op=downloadsConfigMenu", 3, _MD_ERRORURL);
  exit();
}
$newid = $db->genId($db->prefix("mydownloads_downloads")."_lid_seq");
  $ptime = time();
$sql   = "INSERT INTO ".$db->prefix("mydownloads_downloads")." VALUES (".intval($newid).",".intval($cid).",'$groups','$title','$description','$url','$homepage','$version',".intval($size).",'$platform','$logourl',".intval($submitter).",1,".intval($ptime).",0,0,0,0)";
$db->query($sql) or $eh->show("0013");
build_rss();
redirect_header("index.php", 1, _MD_NEWDLADDED);
exit();
}
//---------------------------------------------------------------------------------------//
/**
* Description
*
* @param type $var description
* @return type description
*/
function delNewDownload() {
global $db, $_GET;
$lid   = intval($_GET['lid']);
$query  = "SELECT url, logourl FROM ".$db->prefix("mydownloads_downloads")." WHERE lid=$lid";
$result = $db->query($query);
list($url, $logourl) = $db->fetch_row($result);
@unlink("../cache/files/" . basename($url));
@unlink("../cache/shots/" . basename($logourl));
$query = "DELETE FROM ".$db->prefix("mydownloads_downloads")." WHERE lid=$lid";
$db->query($query);
redirect_header("./index.php?op=listNewDownloads", 1, _MD_FILEDELETED);
exit();
}
//---------------------------------------------------------------------------------------//
/**
* Description
*
* @param type $var description
* @return type description
*/
function modDownload() {
global $db, $_GET, $_POST, $select_files, $select_shots, $myts, $eh, $mytree;
$lid= !empty($_POST['lid']) ? intval($_POST['lid']) : intval($_GET['lid']);
if ( $lid == "" ) {
  redirect_header("index.php?op=downloadsConfigMenu",1);
  exit();
}
$result = $db->query("SELECT cid, title, groups, description, url, homepage, version, size, platform, logourl, status FROM ".$db->prefix("mydownloads_downloads")." WHERE lid=$lid") or $eh->show("0013");
list($cid, $title, $groups, $description, $url, $homepage, $version, $size, $platform, $logourl, $status) = $db->fetch_row($result);
$homepage    = $myts->makeTboxData4Edit($homepage);
$title       = $myts->makeTboxData4Edit($title);
$description = $myts->makeTboxData4Edit($description);
$url         = $myts->makeTboxData4Edit($url);
$version     = $myts->makeTboxData4Edit($version);
$size        = $myts->makeTboxData4Edit($size);
$platform    = $myts->makeTboxData4Edit($platform);
$logourl     = $myts->makeTboxData4Edit($logourl);
xoops_cp_header();
OpenTable();
?>
<form method="post" action="index.php" enctype="multipart/form-data">
<h4><a href="index.php"><?php echo _MAIN;?></a>: <?php echo _MD_MODDL;?></h4><br />
<table width="100%"><tr>
<td valign="top"><?php echo _MD_GROUPSACCESS;?></td>
<td valign="top"><?php XoopsDownload::printGroups(explode(",",$groups));?></td></tr>
<tr>
<td><?php echo _MD_FILEID;?></td>
<td><b><?php echo $lid;?></b></td>
</tr><tr>
<td><?php echo _MD_FILETITLE;?></td>
<td><input type="text" class="text" name="title" value="<?php echo $title;?>" size="50" maxlength="100" /></td>
</tr><tr>
<td valign="top"><?php echo _MD_DLURL;?></td>
<td>
<?php
echo "<i>"._AM_ADDAFILE."</i><br /><br />";
echo _AM_FILESAVAILLIST."<br />";
$select_files->setValue($url);
$select_files->setExtra("onchange=\"javascript:xoopsGetElementById('url').value = this.options[this.selectedIndex].value;\"");
echo $select_files->render(); ?><br /><br />
<input type="text" class="text" name="url" id="url" value="<?php echo $url;?>" size="50" maxlength="255" /> [ <a href="<?php echo formatURL(XOOPS_URL."/modules/mydownloads/cache/files/", $url);?>" target="_blank"><?php echo _MD_DOWNLOAD;?></a> ]
<br /><input type="file" class="file" name="download">
</td>
</tr><tr>
<td>&nbsp;</td>
<td><?php printf(_MD_FILE, "modules/mydownloads/cache/files/");?></td>
</tr><tr>
<td><?php echo _MD_CATEGORYC;?></td>
<td><?php $mytree->makeMySelBox("title", "title", $cid);?></td>
</tr><tr>
<td><?php echo _MD_SITEURL;?></td>
<td><input type="text" class="text" name="homepage" value="<?php echo $homepage;?>" size="50" maxlength="255" /></td>
</tr><tr>
<td><?php echo _MD_VERSIONC;?></td>
<td><input type="text" class="text" name="version" value="<?php echo $version;?>" size="10" maxlength="10" /></td>
</tr><tr>
<td><?php echo _MD_FILESIZEC;?></td>
<td><input type="text" class="text" name="size" value="<?php echo $size;?>" size="10" maxlength="100" /> <?php echo _BYTES;?></td>
</tr><tr>
<td><?php echo _MD_PLATFORMC;?></td>
<td><input type="text" class="text" name="platform" value="<?php echo $platform;?>" size="45" maxlength="60" /></td>
</tr><tr>
<td valign="top"><?php echo _MD_DESCRIPTIONC;?></td>
<td>
<?php
//$desc = new XoopsFormDhtmlTextArea('', 'filedesc', $description,10,58);
$desc = new XoopsFormDhtmlTextArea('', 'filedesc', $description);
echo $desc->render();
?>
</td>
</tr><tr>
<td valign="top"><?php echo _MD_SHOTIMAGE;?></td>
<td>
<?php
echo "<i>"._AM_ADDANIMAGE."</i><br /><br />";
echo _AM_IMGAVAILLIST."<br />";
$select_shots->setValue($logourl);
$select_shots->setExtra("onchange=\"javascript:xoopsGetElementById('logourl').value = this.options[this.selectedIndex].value;\"");
echo $select_shots->render(); ?> [<a href="javascript:openWithSelfMain('<?php echo XOOPS_URL."/modules/mydownloads/cache/shots/";?>' + xoopsGetElementById('indirshots').options[xoopsGetElementById('indirshots').selectedIndex].value + '','view',550,200);"><?php echo _PREVIEW;?></a>]<br /><br />
<input type="text" class="text" name="logourl" id="logourl" value="<?php echo $logourl;?>" size="50" maxlength="255" />
<br /><input type="file" class="file" name="image">
</td>
</tr><tr>
<td>&nbsp;</td>
<td><?php printf(_MD_SHOT, "modules/mydownloads/cache/images/shots/");?></td>
</tr>
<tr>
<td><?php echo _MD_DLSTATUS; ?></td>
<td><select name="dlstatus" id="dlstatus" class="select">
<option value="3"<?php if ( intval($status) == 3 ) { echo " selected"; } ?>><?php echo _MD_DLSTATUSNORMAL; ?></option>
<option value="1"<?php if ( intval($status) == 1 ) { echo " selected"; } ?>><?php echo _MD_DLSTATUSNEW; ?></option>
<option value="2"<?php if ( intval($status) == 2 ) { echo " selected"; } ?>><?php echo _MD_DLSTATUSUPDATED; ?></option>
</select></td>
</tr>
<tr>
<td>
<input type="hidden" name="lid" value="<?php echo $lid;?>" />
<input type="hidden" name="op" value="modDownloadS" />
<input type="submit" class="button" value="<?php echo _SUBMIT;?>" />
</form>
</td>
<td>
<table><tr>
<td><?php echo myTextForm("index.php?op=delDownload&lid=$lid" , _DELETE);?></td>
<td><?php echo myTextForm("index.php?op=downloadsConfigMenu", _CANCEL);?></td>
</tr></table>
</td>
</tr></table><hr />
<?php
$result5 = $db->query("SELECT COUNT(*) FROM ".$db->prefix("mydownloads_votedata")."");
list($totalvotes) = $db->num_rows($result5);
echo "<table valign='top' width='100%'><tr><td colspan='7'><b>";
printf(_MD_DLRATINGS, $totalvotes);
echo "</b><br /><br /></td></tr>";
// Show Registered Users Votes
$result5 = $db->query("SELECT ratingid, ratinguser, rating, ratinghostname, ratingtimestamp FROM ".$db->prefix("mydownloads_votedata")." WHERE lid = $lid AND ratinguser != 0 ORDER BY ratingtimestamp DESC");
$votes   = $db->num_rows($result5);
echo "<tr><td colspan='7'><br /><br /><b>";
printf(_MD_REGUSERVOTES, $votes);
echo "
</b><br /><br /></td>
</tr><tr>
<td><b>"._MD_USER."</b></td>
<td><b>"._MD_IP."</b></td>
<td><b>"._MD_RATING."</b></td>
<td><b>"._MD_USERAVG."</b></td>
<td><b>"._MD_TOTALRATE."</b></td>
<td><b>"._MD_DATE."</b></td>
<td align='center'><b>"._DELETE."</b></td>
</tr>";
if ($votes == 0) {
  echo "<tr><td align='center' colspan='7'>"._MD_NOREGVOTES."<br /></td></tr>";
}
$x=0;
$colorswitch = "bg1";
while (list($ratingid, $ratinguser, $rating, $ratinghostname, $ratingtimestamp)=$db->fetch_row($result5)) {
  $formatted_date = formatTimestamp($ratingtimestamp, "s");
  $result2        = $db->query("SELECT rating FROM ".$db->prefix("mydownloads_votedata")." WHERE ratinguser=$ratinguser");
  $uservotes      = $db->num_rows($result2);
  $useravgrating  = 0;
  while (list($rating2) = $db->fetch_row($result2)) {
    $useravgrating = ($useravgrating + $rating2);
  }
  $useravgrating = ($useravgrating / $uservotes);
  $useravgrating = number_format($useravgrating, 1);
  $ratinguname   = XoopsUser::getUnameFromId($ratinguser);
  echo "
  <tr>
  <td class='$colorswitch'>$ratinguname</td>
  <td class='$colorswitch'>$ratinghostname</td>
  <td class='$colorswitch'>$rating</td>
  <td class='$colorswitch'>$useravgrating</td>
  <td class='$colorswitch'>$uservotes</td>
  <td class='$colorswitch'>$formatted_date</td>
  <td class='$colorswitch' align='center'>";
  echo myTextForm("index.php?op=delVote&lid=$lid&rid=$ratingid", "X");
  echo "</td></tr>";
  $x++;
  if ($colorswitch == "bg1") {
    $colorswitch = "bg3";
    } else {
      $colorswitch = "bg1";
    }
}
// Show Unregistered Users Votes
$result5 = $db->query("SELECT ratingid, rating, ratinghostname, ratingtimestamp FROM ".$db->prefix("mydownloads_votedata")." WHERE lid = $lid AND ratinguser = 0 ORDER BY ratingtimestamp DESC");
$votes   = $db->num_rows($result5);
echo "<tr><td colspan='7'><br /><br /><b>";
printf(_MD_ANONUSERVOTES, $votes);
echo "
</b><br /><br /></td>
</tr><tr>
<td colspan='2'><b>"._MD_IP."</b></td>
<td colspan='3'><b>"._MD_RATING."</b></td>
<td><b>"._MD_DATE."</b></b></td>
<td align='center'><b>"._DELETE."</b></td>
</tr>";
if ($votes == 0) {
  echo "<tr><td colspan='7' align='center'>"._MD_NOUNREGVOTES."</td></tr>";
}
$x=0;
$colorswitch = "bg1";
while (list($ratingid, $rating, $ratinghostname, $ratingtimestamp) = $db->fetch_row($result5)) {
  $formatted_date = formatTimestamp($ratingtimestamp, "s");
  echo "
  <td colspan='2' class='$colorswitch'>$ratinghostname</td>
  <td colspan='3' class='$colorswitch'>$rating</td>
  <td class='$colorswitch'>$formatted_date</td>
  <td class='$colorswitch' align='center'>";
  echo myTextForm("index.php?op=delVote&lid=$lid&rid=$ratingid", "X");
  echo "</td></tr>";
  $x++;
  if ($colorswitch == "bg1") {
    $colorswitch = "bg3";
    } else {
      $colorswitch="bg1";
    }
}
echo "<tr><td colspan='6'>&nbsp;</td></tr></table>";
CloseTable();
xoops_cp_footer();
}
//---------------------------------------------------------------------------------------//
/**
* Description
*
* @param type $var description
* @return type description
*/
function modDownloadS() {
global $db, $myts, $eh, $_POST, $_FILES, $xoopsModule;
$groups  = XoopsDownload::makeTboxData4SaveGroups($_POST["group_ids"]);
$cid         = intval($_POST['cid']);
$lid         = intval($_POST['lid']);
$homepage    = formatURL($myts->makeTboxData4Save($_POST["homepage"]));
$url         = $myts->makeTboxData4Save($_POST["url"]);
$logourl     = $myts->makeTboxData4Save($_POST["logourl"]);
$title       = $myts->makeTboxData4Save($_POST["title"]);
$version     = $myts->makeTboxData4Save($_POST["version"]);
$platform    = $myts->makeTboxData4Save($_POST["platform"]);
$description = $myts->makeTboxData4Save($_POST["filedesc"]);
$size        = intval($_POST['size']);
$dlstatus  = intval($_POST['dlstatus']);
// Check if Title is empty
if ( empty($title) ) {
  redirect_header("index.php?op=modDownload&lid=$lid", 3, _MD_ERRORTITLE);
  exit();
}
// Check if Description is empty
if ( empty($description) ) {
  redirect_header("index.php?op=modDownload&lid=$lid", 3, _MD_ERRORDESC);
  exit();
}
if ( empty($size) || !is_numeric($size) ) {
  $size = 0;
}
if ( !empty($_FILES['download']['name']) || !empty($_FILES['image']['name']) ) {
  $upload = new fileupload();
  $upload->set_upload_dir('../cache/files/', 'download');
  $upload->set_overwrite(1, 'download');
  $upload->set_upload_dir('../cache/shots/', 'image');
  $upload->set_basename($lid, 'image');
  $upload->set_overwrite(2, 'image');
  $result = $upload->upload();
  if (!empty($_FILES['download']['name'])) {
    if ($result['download']['filename']) {
      $url  = $result['download']['filename'];
      $size = $result['download']['size'];
      } else {
        redirect_header("index.php?op=modDownload&lid=$lid", 3, $upload->errors());
        exit();
      }
  }
  if ( !empty($_FILES['image']['name']) ) {
    if ($result['image']['filename']) {
      $logourl = $result['image']['filename'];
      } else {
        redirect_header("index.php?op=modDownload&lid=$lid", 3, $upload->errors());
        exit();
      }
    }
}
// Check if URL is empty
if ( empty($url) ) {
  redirect_header("index.php?op=modDownload&lid=$lid", 3, _MD_ERRORURL);
  exit();
}
$updtime = time();
$sql = "UPDATE ".$db->prefix("mydownloads_downloads")." SET cid=$cid,title='$title',groups='$groups',description='$description',url='$url',homepage='$homepage',version='$version',size='$size',platform='$platform',logourl='$logourl',status=".$dlstatus.",date=".$updtime." WHERE lid=$lid";
$db->query($sql) or $eh->show("0013");
build_rss();
redirect_header("index.php", 1, _UPDATED);
exit();
}
//---------------------------------------------------------------------------------------//
/**
* Description
*
* @param type $var description
* @return type description
*/
function approve() {
global $xoopsConfig, $db, $_POST, $myts, $eh, $meta;
$lid = intval($_POST['lid']);
$cid = intval($_POST['cid']);
if ( empty($cid) ) {
  $cid = 0;
}
$groups  = XoopsDownload::makeTboxData4SaveGroups($_POST["group_ids"]);
$homepage    = formatURL($myts->makeTboxData4Save($_POST["homepage"]));
$url         = $myts->makeTboxData4Save($_POST["url"]);
$logourl     = $myts->makeTboxData4Save($_POST["logourl"]);
$title       = $myts->makeTboxData4Save($_POST["title"]);
$version     = $myts->makeTboxData4Save($_POST["version"]);
$size        = $myts->makeTboxData4Save($_POST["size"]);
$platform    = $myts->makeTboxData4Save($_POST["platform"]);
$description = $myts->makeTboxData4Save($_POST["filedesc"]);
$query = "
  UPDATE
  ".$db->prefix("mydownloads_downloads")."
  SET
  cid=$cid,
  title='$title',
  groups='$groups',
  description='$description',
  url='$url',
  homepage='$homepage',
  version='$version',
  size='$size',
  platform='$platform',
  logourl='$logourl',
  status=1,
  date=".time()."
  WHERE
  lid=$lid";
$db->query($query) or $eh->show("0013");
$result = $db->query("SELECT submitter FROM ".$db->prefix("mydownloads_downloads")." WHERE lid=$lid");
list($submitter) = $db->fetch_row($result);
  $submitter = new XoopsUser($submitter);
  $subject   = sprintf(_MD_YOURFILEAT, $meta['title']);
  $message   = sprintf(_MD_HELLO, $submitter->uname());
  $message  .= "\n\n"._MD_WEAPPROVED."\n\n";
  $siteurl   = XOOPS_URL."/modules/mydownloads/";
  $message  .= sprintf(_MD_VISITAT, $siteurl);
  $message  .= "\n\n"._MD_THANKSSUBMIT."\n\n".$meta['title']."\n".XOOPS_URL."\n".$xoopsConfig['adminmail']."";
    $xoopsMailer =& getMailer();
  $xoopsMailer->useMail();
  $xoopsMailer->setToEmails($submitter->getVar("email"));
  $xoopsMailer->setFromEmail($xoopsConfig['adminmail']);
  $xoopsMailer->setFromName($meta['title']);
  $xoopsMailer->setSubject($subject);
  $xoopsMailer->setBody($message);
  $xoopsMailer->send();
build_rss();
redirect_header("./index.php?op=listNewDownloads", 1, _MD_NEWDLADDED);
exit();
}
//---------------------------------------------------------------------------------------//
/**
* Description
*
* @param type $var description
* @return type description
*/
function mydownloadsConfigAdmin() {
global $myts, $mydownloadsConfig;
include_once(XOOPS_ROOT_PATH.'/class/xoopsform/formselectgroup.php');
$gselect = new XoopsFormSelectGroup('', 'aa_groups', true, explode(",", $mydownloadsConfig['autoapp_groups']), 5, true);
xoops_cp_header();
OpenTable();
?>
<h4><a href="index.php"><?php echo _MAIN;?></a>: <?php echo _MD_GENERALSET;?></h4><br />
<form action="index.php" method="post">
<table width="100%" border="0"><tr>
<td nowrap><?php echo _MD_DLSPERPAGE;?></td>
<td width="100%">
<select class="select" name="perpage">
<option value="<?php echo $mydownloadsConfig['perpage'];?>" selected="selected"><?php echo $mydownloadsConfig['perpage'];?></option>
<option value="1">1</option>
<option value="2">2</option>
<option value="3">3</option>
<option value="4">4</option>
<option value="5">5</option>
<option value="6">6</option>
<option value="7">7</option>
<option value="8">8</option>
<option value="9">9</option>
<option value="10">10</option>
<option value="15">15</option>
<option value="20">20</option>
<option value="25">25</option>
<option value="30">30</option>
<option value="50">50</option>
</select>
</td>
</tr><tr>
<td nowrap><?php echo _MD_HITSPOP;?></td>
<td width="100%">
<select class="select" name="popular">
<option value="<?php echo $mydownloadsConfig['popular'];?>" selected="selected"><?php echo $mydownloadsConfig['popular'];?></option>
<option value="10">10</option>
<option value="20">20</option>
<option value="50">50</option>
<option value="100">100</option>
<option value="500">500</option>
<option value="1000">1000</option>
</select>
</td>
</tr><tr>
<td nowrap><?php echo _MD_DLSNEW;?></td>
<td width="100%">
<select class="select" name="newdownloads">
<option value="<?php echo $mydownloadsConfig['newdownloads'];?>" selected="selected"><?php echo $mydownloadsConfig['newdownloads'];?></option>
<option value="1">1</option>
<option value="2">2</option>
<option value="3">3</option>
<option value="4">4</option>
<option value="5">5</option>
<option value="6">6</option>
<option value="7">7</option>
<option value="8">8</option>
<option value="9">9</option>
<option value="10">10</option>
<option value="15">15</option>
<option value="20">20</option>
<option value="25">25</option>
<option value="30">30</option>
<option value="50">50</option>
</select>
</td>
</tr><tr>
<?php
$chk1 = ''; $chk0 = '';
($mydownloadsConfig['useshots'] == 1) ? $chk1 = " checked='checked'" : $chk0 = " checked='checked'";
?>
<td nowrap><?php echo _MD_USESHOTS;?></td>
<td width="100%">
<input type="radio" class="radio" name="useshots" value="1"<?php echo $chk1;?> /> <?php echo _YES;?>
<input type="radio" class="radio" name="useshots" value="0"<?php echo $chk0;?> /> <?php echo _NO;?>
</td>
</tr><tr>
<td nowrap><?php echo _MD_IMGWIDTH;?></td>
<td width="100%">
<input type="text" class="text" size="10" name="shotwidth" value="<?php echo $mydownloadsConfig['shotwidth'];?>" />
</td>
</tr><tr>
<?php
$chk1 = ''; $chk0 = '';
($mydownloadsConfig['anon_add'] == 1) ? $chk1 = " checked='checked'" : $chk0 = " checked='checked'";
?>
<td nowrap><?php echo _AM_ANON_ADD;?></td>
<td width="100%">
<input type="radio" class="radio" name="anon_add" value="1"<?php echo $chk1;?> /> <?php echo _YES;?>
<input type="radio" class="radio" name="anon_add" value="0"<?php echo $chk0;?> /> <?php echo _NO;?>
</td></tr><tr>
<?php
$chk1 = ''; $chk0 = '';
($mydownloadsConfig['check_external'] == 1) ? $chk1 = " checked='checked'" : $chk0 = " checked='checked'";
?>
<td nowrap><?php echo _AM_CHECK_EXTERNAL;?></td>
<td width="100%">
<input type="radio" class="radio" name="check_external" value="1"<?php echo $chk1;?> /> <?php echo _YES;?>
<input type="radio" class="radio" name="check_external" value="0"<?php echo $chk0;?> /> <?php echo _NO;?>
</td></tr><tr>
<td colspan="2"><hr /></td>
</tr><tr>
<?php
$chk1 = ''; $chk0 = '';
($mydownloadsConfig['rss_enable'] == 1) ? $chk1 = " checked='checked'" : $chk0 = " checked='checked'";
?>
<td nowrap><?php echo _AM_RSS_ENABLE;?></td>
<td width="100%">
<input type="radio" class="radio" name="rss_enable" value="1"<?php echo $chk1;?> /> <?php echo _YES;?>
<input type="radio" class="radio" name="rss_enable" value="0"<?php echo $chk0;?> /> <?php echo _NO;?>
</td></tr><tr>
<td nowrap><?php echo _AM_RSS_MAXITEMS;?></td>
<td width="100%">
<select class="select" name="rss_maxitems">
<option value="<?php echo $mydownloadsConfig['rss_maxitems'];?>" selected="selected"><?php echo $mydownloadsConfig['rss_maxitems'];?></option>
<option value="5">5</option>
<option value="10">10</option>
<option value="15">15</option>
<option value="20">20</option>
<option value="25">25</option>
<option value="30">30</option>
</select>
</td></tr><tr>
<td nowrap><?php echo _AM_RSS_MAXDESCRIPTION;?></td>
<td width="100%">
<select class="select" name="rss_maxdescription">
<option value="<?php echo $mydownloadsConfig['rss_maxdescription'];?>" selected="selected"><?php echo $mydownloadsConfig['rss_maxdescription'];?></option>
<option value="50">50</option>
<option value="100">100</option>
<option value="150">150</option>
<option value="200">200</option>
<option value="250">250</option>
<option value="300">300</option>
</select>
</td></tr><tr>
<td colspan="2"><hr /></td></tr><tr>
<?php
$chk1 = ''; $chk0 = '';
($mydownloadsConfig['allow_upload'] == 1) ? $chk1 = " checked='checked'" : $chk0 = " checked='checked'";
?>
<td nowrap><?php echo _UPLOADENABLE;?></td>
<td width="100%">
<input type="radio" class="radio" name="allow_upload" value="1"<?php echo $chk1;?> /> <?php echo _YES;?>
<input type="radio" class="radio" name="allow_upload" value="0"<?php echo $chk0;?> /> <?php echo _NO;?>
</td></tr><tr>
<td nowrap><?php echo _UPLOADACCEPTED;?></td>
<td width="100%">
<input type="text" class="text" size="30" name="accepted_files" value="<?php echo $mydownloadsConfig['accepted_files'];?>" />
</td></tr><tr>
<td nowrap><?php echo _UPLOADLIMIT;?></td>
<td width="100%">
<input type="text" class="text" size="10" name="upload_limit" value="<?php echo $mydownloadsConfig['upload_limit'];?>" /> <?php echo _BYTES;?>
</td></tr><tr>
<td colspan="2"><hr /></td>
</tr><tr>
<td valign="top" nowrap><?php echo _AM_DISCLAIMER;?></td>
<td width="100%">
<?php
$disclaimer = join('', file("../cache/disclaimer.php"));
$disclaimer = $myts->makeTboxData4PreviewInForm($disclaimer);
//$desc       = new XoopsFormDhtmlTextArea('', 'disclaimer', $disclaimer, 10, 58);
$desc       = new XoopsFormDhtmlTextArea('', 'disclaimer', $disclaimer);
echo $desc->render();
?>
</td></tr><tr>
<td colspan="2"><hr /></td>
</tr><tr>
<td colspan="2">
<input type="hidden" name="op" value="mydownloadsConfigChange">
<input type="submit" class="button" value="<?php echo _SAVE;?>">
<input type="button" class="button" value="<?php echo _CANCEL;?>" onclick="javascript:history.go(-1)">
</td></tr></table>
</form>
<?php
CloseTable();
xoops_cp_footer();
}
//---------------------------------------------------------------------------------------//
/**
* Description
*
* @param type $var description
* @return type description
*/
function mydownloadsConfigChange() {
global  $_POST, $myts;
$content  = "<?php\n";
$content .= "\$mydownloadsConfig['popular']            = ".intval($_POST['popular']).";\n";
$content .= "\$mydownloadsConfig['newdownloads']       = ".intval($_POST['newdownloads']).";\n";
$content .= "\$mydownloadsConfig['perpage']            = ".intval($_POST['perpage']).";\n";
$content .= "\$mydownloadsConfig['useshots']           = ".intval($_POST['useshots']).";\n";
$content .= "\$mydownloadsConfig['shotwidth']          = ".intval($_POST['shotwidth']).";\n";
$content .= "\$mydownloadsConfig['anon_add']           = ".intval($_POST['anon_add']).";\n";
$content .= "\$mydownloadsConfig['check_external']     = ".intval($_POST['check_external']).";\n";
$content .= "\$mydownloadsConfig['rss_enable']         = ".intval($_POST['rss_enable']).";\n";
$content .= "\$mydownloadsConfig['rss_maxitems']       = ".intval($_POST['rss_maxitems']).";\n";
$content .= "\$mydownloadsConfig['rss_maxdescription'] = ".intval($_POST['rss_maxdescription']).";\n";
$content .= "\$mydownloadsConfig['allow_upload']       = ".intval($_POST['allow_upload']).";\n";
$content .= "\$mydownloadsConfig['accepted_files']     = '".$_POST['accepted_files']."';\n";
$content .= "\$mydownloadsConfig['upload_limit']       = ".intval($_POST['upload_limit']).";\n";
$content .= "?>";
$filename = "../cache/config.php";
if ( $file = fopen($filename, "w") ) {
  fwrite($file, $content);
  fclose($file);
  } else {
    redirect_header("index.php", 1, _NOTUPDATED);
    exit();
  }
$filename = "../cache/disclaimer.php";
if ( $file = fopen($filename, "wb") ) {
  $disclaimer = $myts->oopsStripSlashesGPC($_POST['disclaimer']);
  fwrite($file, $disclaimer);
  fclose($file);
  } else {
    redirect_header("index.php", 1, _NOTUPDATED);
    exit();
  }
redirect_header("index.php", 1, _UPDATED);
exit();
}
//---------------------------------------------------------------------------------------//
/**
* Description
*
* @param type $var description
* @return type description
*/
function build_rss() {
global $db, $mydownloadsConfig;
if ($mydownloadsConfig['rss_enable'] == 1) {
$SQL= "SELECT title, lid, version, description FROM ".$db->prefix("mydownloads_downloads")." WHERE status <> 0 ORDER BY date DESC";
$query = $db->query($SQL, $mydownloadsConfig['rss_maxitems']);
if ($query) {
  $rss = new xml_rss(XOOPS_ROOT_PATH . '/modules/mydownloads/cache/downloads.xml');
  $rss->channel_title       .= " :: " . _MI_MYDOWNLOADS_NAME;
  $rss->image_title         .= " :: " . _MI_MYDOWNLOADS_NAME;
  $rss->max_items            = $mydownloadsConfig['rss_maxitems'];
  $rss->max_item_description = $mydownloadsConfig['rss_maxdescription'];

  while ( list($title, $link, $version, $description) = $db->fetch_row($query) ) {
    $link = XOOPS_URL . '/modules/mydownloads/singlefile.php?lid=' . $link;
    if ( !empty($version) ) { $title .= " - ".$version; }
    $rss->build($title, $link, $description);
  }
  $rss->save();
  }
}
}
//---------------------------------------------------------------------------------------//
$op = !empty($_POST['op']) ? $_POST['op'] : $_GET['op'];
switch($op) {
case "delNewDownload":
  delNewDownload();
  break;
case "approve":
  approve();
  break;
case "addCat":
  addCat();
  break;
case "addSubCat":
  addSubCat();
  break;
case "addDownload":
  addDownload();
  break;
case "listBrokenDownloads":
  listBrokenDownloads();
  break;
case "delBrokenDownloads":
  delBrokenDownloads();
  break;
case "ignoreBrokenDownloads":
  ignoreBrokenDownloads();
  break;
case "listModReq":
  listModReq();
  break;
case "changeModReq":
  changeModReq();
  break;
case "ignoreModReq":
  ignoreModReq();
  break;
case "delCat":
  delCat();
  break;
case "modCat":
  modCat();
  break;
case "modCatS":
  modCatS();
  break;
case "modDownload":
  modDownload();
  break;
case "modDownloadS":
  modDownloadS();
  break;
case "delDownload":
  delDownload();
  break;
case "delVote":
  delVote();
  break;
case "mydownloadsConfigAdmin":
  mydownloadsConfigAdmin();
  break;
case "mydownloadsConfigChange":
  mydownloadsConfigChange();
  break;
case "downloadsConfigMenu":
  downloadsConfigMenu();
  break;
case "listNewDownloads":
  listNewDownloads();
  break;
default:
  mydownloads();
  break;
}
?>
